//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LightSeaGreen
#property indicator_color2  Red
#property indicator_color3  PaleVioletRed
#property indicator_width3  2

//
//
//
//
//

extern bool showOvearAllStats = false;
extern bool showUniqueLengths = false;
extern int  barsToCountStats  = 0;

//
//
//
//

double stats[];
double UpBuffer[];
double DnBuffer[];
double Stat[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   string short_name;
      SetIndexBuffer(0,UpBuffer); SetIndexLabel(0,"UP");
      SetIndexBuffer(1,DnBuffer); SetIndexLabel(1,"DOWN");
      SetIndexBuffer(2,Stat);
      
         if (showOvearAllStats)
         {
            SetIndexStyle(0,DRAW_NONE); 
            SetIndexStyle(1,DRAW_NONE); 
            SetIndexStyle(2,DRAW_HISTOGRAM); 
         }
         else
         {
            SetIndexStyle(0,DRAW_HISTOGRAM); 
            SetIndexStyle(1,DRAW_HISTOGRAM); 
            SetIndexStyle(2,DRAW_NONE); 
         }
   IndicatorShortName("Up/Down");
   return(0);
}

//
//
//
//
//

int start()
{
   int k,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit  = MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      for (k=0; (i+k+2)<Bars; k++) if (Close[i+k+1]<Open[i+k+2]) break; UpBuffer[i]= k; 
      for (k=0; (i+k+2)<Bars; k++) if (Close[i+k+1]>Open[i+k+2]) break; DnBuffer[i]=-k;
      
   }
   if (showOvearAllStats)
   {
      if (barsToCountStats<=0)
            limit = Bars-1;
      else  limit = MathMin(Bars-1,barsToCountStats);
         ArrayInitialize(stats,0);
         for(i=limit; i>=0; i--)
         {
            int size = MathMax(UpBuffer[i],-DnBuffer[i])+1;
            if (ArraySize(stats)<size) { ArrayResize(stats,size); stats[size-1] = 0; } 
            
            //
            //
            //
            //
            //
            
            bool condition;

               if (showUniqueLengths)
                     condition = (UpBuffer[i]>UpBuffer[i-1]);
               else  condition = true;
               if (condition) { k =  UpBuffer[i]; stats[k]++; }

            //
            //
            //
            //
            //
            
            if (showUniqueLengths)
                  condition = (DnBuffer[i]<DnBuffer[i-1]);
            else  condition = true;
            if (condition) {  k = -DnBuffer[i]; stats[k]++; }
         }
         for (i=ArraySize(stats); i>0; i--)  Stat[i-1] = stats[i];
         SetIndexDrawBegin(2,Bars-ArraySize(stats));
   }
   return(0);
}